/*
 * Copyright (c) 2016-2019 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 *                                      Anthony Mallet on Tue Aug 23 2016
 */
#ifndef H_MRSIM_CODELS
#define H_MRSIM_CODELS

#include <sys/time.h>
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>

#include "mrsim_c_types.h"
#include "libmrsim.h"

static inline genom_event
mrsim_e_sys_error(const char *s, genom_context self)
{
  mrsim_e_sys_detail d;
  size_t l = 0;

  d.code = errno;
  if (s) {
    strncpy(d.what, s, sizeof(d.what) - 3);
    l = strlen(s);
    strcpy(d.what + l, ": ");
    l += 2;
  }
  strerror_r(d.code, d.what + l, sizeof(d.what) - l);
  return mrsim_e_sys(&d, self);
}


void	mrsim_update_state(const mrsim_s *mrsim,
                or_pose_estimator_state *state);
void	mrsim_addnoise(const struct mrsim_s *mrsim,
                or_pose_estimator_state *state);

#endif /* H_MRSIM_CODELS */
